"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const TweetArchive_1 = __importDefault(require("./TweetArchive"));
/**
 * Parse a raw Twitter date, like from a `dm.createdAt`.
 *
 * For a tweet, please use `TweetArchive.dateFromTweet(tweet)` instead, it's optimized !
 *
 * For a `LinkedDirectMessage`, use property `.createdAtDate` !
 */
exports.parseTwitterDate = TweetArchive_1.default.parseTwitterDate;
function* getEventsFromMessages(msgs, include_messages = false) {
    function* addEvents(e) {
        for (const [key, vals] of Object.entries(e)) {
            for (const val of vals) {
                yield { [key]: val };
            }
        }
    }
    let first = true;
    for (const msg of msgs) {
        if (first) {
            first = false;
            if (msg.events && msg.events.before) {
                yield* addEvents(msg.events.before);
            }
        }
        if (include_messages) {
            yield { messageCreate: msg };
        }
        if (msg.events && msg.events.after) {
            yield* addEvents(msg.events.after);
        }
    }
}
exports.getEventsFromMessages = getEventsFromMessages;
